diff -urwN -X /home/jonathan/diff/exclude.txt mdl-cvshead/lib/db/access.php mdl20-mitms-integration/lib/db/access.php
--- mdl-cvshead/lib/db/access.php	2009-08-25 11:49:00.000000000 +1200
+++ mdl20-mitms-integration/lib/db/access.php	2009-08-25 16:23:07.000000000 +1200
@@ -1381,6 +1381,17 @@
             'coursecreator' => CAP_ALLOW,
             'admin' => CAP_ALLOW
         )
+    ),
+
+    'moodle/course:markcomplete' => array(
+        'captype' => 'write',
+        'contextlevel' => CONTEXT_COURSE,
+        'legacy' => array(
+            'teacher' => CAP_ALLOW,
+            'editingteacher' => CAP_ALLOW,
+            'coursecreator' => CAP_ALLOW,
+            'admin' => CAP_ALLOW
+        )
     )
 );
 
diff -urwN -X /home/jonathan/diff/exclude.txt mdl-cvshead/lib/db/upgrade.php mdl20-mitms-integration/lib/db/upgrade.php
--- mdl-cvshead/lib/db/upgrade.php	2009-08-25 11:49:00.000000000 +1200
+++ mdl20-mitms-integration/lib/db/upgrade.php	2009-08-25 16:29:06.000000000 +1200
@@ -2370,6 +2370,157 @@
         upgrade_main_savepoint($result, 2009072400);
     }
 
+    if ($result && $oldversion < 2009082500) {
+
+    /// Add course completion tables
+    /// Define table course_completion_aggr_methd to be created
+        $table = new xmldb_table('course_completion_aggr_methd');
+
+    /// Adding fields to table course_completion_aggr_methd
+        $table->add_field('id', XMLDB_TYPE_INTEGER, '10', XMLDB_UNSIGNED, XMLDB_NOTNULL, XMLDB_SEQUENCE, null);
+        $table->add_field('course', XMLDB_TYPE_INTEGER, '10', XMLDB_UNSIGNED, XMLDB_NOTNULL, null, '0');
+        $table->add_field('criteriatype', XMLDB_TYPE_INTEGER, '20', XMLDB_UNSIGNED, null, null, null);
+        $table->add_field('method', XMLDB_TYPE_INTEGER, '1', XMLDB_UNSIGNED, XMLDB_NOTNULL, null, '0');
+        $table->add_field('value', XMLDB_TYPE_NUMBER, '10, 5', null, null, null, null);
+
+    /// Adding keys to table course_completion_aggr_methd
+        $table->add_key('primary', XMLDB_KEY_PRIMARY, array('id'));
+
+    /// Adding indexes to table course_completion_aggr_methd
+        $table->add_index('course', XMLDB_INDEX_NOTUNIQUE, array('course'));
+        $table->add_index('criteriatype', XMLDB_INDEX_NOTUNIQUE, array('criteriatype'));
+
+    /// Conditionally launch create table for course_completion_aggr_methd
+        if (!$dbman->table_exists($table)) {
+            $dbman->create_table($table);
+        }
+
+
+    /// Define table course_completion_criteria to be created
+        $table = new xmldb_table('course_completion_criteria');
+
+    /// Adding fields to table course_completion_criteria
+        $table->add_field('id', XMLDB_TYPE_INTEGER, '10', XMLDB_UNSIGNED, XMLDB_NOTNULL, XMLDB_SEQUENCE, null);
+        $table->add_field('course', XMLDB_TYPE_INTEGER, '10', XMLDB_UNSIGNED, XMLDB_NOTNULL, null, '0');
+        $table->add_field('criteriatype', XMLDB_TYPE_INTEGER, '20', XMLDB_UNSIGNED, XMLDB_NOTNULL, null, '0');
+        $table->add_field('module', XMLDB_TYPE_CHAR, '100', null, null, null, null);
+        $table->add_field('moduleinstance', XMLDB_TYPE_INTEGER, '10', XMLDB_UNSIGNED, null, null, null);
+        $table->add_field('enrolperiod', XMLDB_TYPE_INTEGER, '10', XMLDB_UNSIGNED, null, null, null);
+        $table->add_field('date', XMLDB_TYPE_INTEGER, '10', XMLDB_UNSIGNED, null, null, null);
+        $table->add_field('gradepass', XMLDB_TYPE_NUMBER, '10, 5', null, null, null, null);
+        $table->add_field('role', XMLDB_TYPE_INTEGER, '10', XMLDB_UNSIGNED, null, null, null);
+        $table->add_field('lock', XMLDB_TYPE_INTEGER, '10', XMLDB_UNSIGNED, null, null, null);
+
+    /// Adding keys to table course_completion_criteria
+        $table->add_key('primary', XMLDB_KEY_PRIMARY, array('id'));
+
+    /// Adding indexes to table course_completion_criteria
+        $table->add_index('course', XMLDB_INDEX_NOTUNIQUE, array('course'));
+        $table->add_index('lock', XMLDB_INDEX_NOTUNIQUE, array('lock'));
+
+    /// Conditionally launch create table for course_completion_criteria
+        if (!$dbman->table_exists($table)) {
+            $dbman->create_table($table);
+        }
+
+
+    /// Define table course_completion_crit_compl to be created
+        $table = new xmldb_table('course_completion_crit_compl');
+
+    /// Adding fields to table course_completion_crit_compl
+        $table->add_field('id', XMLDB_TYPE_INTEGER, '10', XMLDB_UNSIGNED, XMLDB_NOTNULL, XMLDB_SEQUENCE, null);
+        $table->add_field('userid', XMLDB_TYPE_INTEGER, '10', XMLDB_UNSIGNED, XMLDB_NOTNULL, null, '0');
+        $table->add_field('course', XMLDB_TYPE_INTEGER, '10', XMLDB_UNSIGNED, XMLDB_NOTNULL, null, '0');
+        $table->add_field('criteriaid', XMLDB_TYPE_INTEGER, '10', XMLDB_UNSIGNED, XMLDB_NOTNULL, null, '0');
+        $table->add_field('gradefinal', XMLDB_TYPE_NUMBER, '10, 5', null, null, null, null);
+        $table->add_field('unenroled', XMLDB_TYPE_INTEGER, '10', XMLDB_UNSIGNED, null, null, null);
+        $table->add_field('deleted', XMLDB_TYPE_INTEGER, '1', XMLDB_UNSIGNED, null, null, null);
+        $table->add_field('timecompleted', XMLDB_TYPE_INTEGER, '10', XMLDB_UNSIGNED, null, null, null);
+
+    /// Adding keys to table course_completion_crit_compl
+        $table->add_key('primary', XMLDB_KEY_PRIMARY, array('id'));
+
+    /// Adding indexes to table course_completion_crit_compl
+        $table->add_index('userid', XMLDB_INDEX_NOTUNIQUE, array('userid'));
+        $table->add_index('course', XMLDB_INDEX_NOTUNIQUE, array('course'));
+        $table->add_index('criteriaid', XMLDB_INDEX_NOTUNIQUE, array('criteriaid'));
+        $table->add_index('timecompleted', XMLDB_INDEX_NOTUNIQUE, array('timecompleted'));
+
+    /// Conditionally launch create table for course_completion_crit_compl
+        if (!$dbman->table_exists($table)) {
+            $dbman->create_table($table);
+        }
+
+
+    /// Define table course_completion_notify to be created
+        $table = new xmldb_table('course_completion_notify');
+
+    /// Adding fields to table course_completion_notify
+        $table->add_field('id', XMLDB_TYPE_INTEGER, '10', XMLDB_UNSIGNED, XMLDB_NOTNULL, XMLDB_SEQUENCE, null);
+        $table->add_field('course', XMLDB_TYPE_INTEGER, '10', XMLDB_UNSIGNED, XMLDB_NOTNULL, null, '0');
+        $table->add_field('role', XMLDB_TYPE_INTEGER, '10', XMLDB_UNSIGNED, XMLDB_NOTNULL, null, '0');
+        $table->add_field('message', XMLDB_TYPE_TEXT, 'small', null, XMLDB_NOTNULL, null, null);
+        $table->add_field('timesent', XMLDB_TYPE_INTEGER, '10', XMLDB_UNSIGNED, XMLDB_NOTNULL, null, '0');
+
+    /// Adding keys to table course_completion_notify
+        $table->add_key('primary', XMLDB_KEY_PRIMARY, array('id'));
+
+    /// Adding indexes to table course_completion_notify
+        $table->add_index('course', XMLDB_INDEX_NOTUNIQUE, array('course'));
+
+    /// Conditionally launch create table for course_completion_notify
+        if (!$dbman->table_exists($table)) {
+            $dbman->create_table($table);
+        }
+
+    /// Define table course_completions to be created
+        $table = new xmldb_table('course_completions');
+
+    /// Adding fields to table course_completions
+        $table->add_field('id', XMLDB_TYPE_INTEGER, '10', XMLDB_UNSIGNED, XMLDB_NOTNULL, XMLDB_SEQUENCE, null);
+        $table->add_field('userid', XMLDB_TYPE_INTEGER, '10', XMLDB_UNSIGNED, XMLDB_NOTNULL, null, '0');
+        $table->add_field('course', XMLDB_TYPE_INTEGER, '10', XMLDB_UNSIGNED, XMLDB_NOTNULL, null, '0');
+        $table->add_field('deleted', XMLDB_TYPE_INTEGER, '1', XMLDB_UNSIGNED, null, null, null);
+        $table->add_field('timenotified', XMLDB_TYPE_INTEGER, '10', XMLDB_UNSIGNED, null, null, null);
+        $table->add_field('timeenroled', XMLDB_TYPE_INTEGER, '10', XMLDB_UNSIGNED, XMLDB_NOTNULL, null, '0');
+        $table->add_field('timecompleted', XMLDB_TYPE_INTEGER, '10', XMLDB_UNSIGNED, null, null, null);
+
+    /// Adding keys to table course_completions
+        $table->add_key('primary', XMLDB_KEY_PRIMARY, array('id'));
+
+    /// Adding indexes to table course_completions
+        $table->add_index('userid', XMLDB_INDEX_NOTUNIQUE, array('userid'));
+        $table->add_index('course', XMLDB_INDEX_NOTUNIQUE, array('course'));
+        $table->add_index('timecompleted', XMLDB_INDEX_NOTUNIQUE, array('timecompleted'));
+
+    /// Conditionally launch create table for course_completions
+        if (!$dbman->table_exists($table)) {
+            $dbman->create_table($table);
+        }
+
+
+    /// Add cols to course table
+    /// Define field enablecompletion to be added to course
+        $table = new xmldb_table('course');
+        $field = new xmldb_field('enablecompletion', XMLDB_TYPE_INTEGER, '1', XMLDB_UNSIGNED, XMLDB_NOTNULL, null, '0', 'defaultrole');
+
+    /// Conditionally launch add field enablecompletion
+        if (!$dbman->field_exists($table, $field)) {
+            $dbman->add_field($table, $field);
+        }
+
+    /// Define field completionnotify to be added to course
+        $field = new xmldb_field('completionnotify', XMLDB_TYPE_INTEGER, '1', XMLDB_UNSIGNED, XMLDB_NOTNULL, null, '0', 'enablecompletion');
+
+    /// Conditionally launch add field completionnotify
+        if (!$dbman->field_exists($table, $field)) {
+            $dbman->add_field($table, $field);
+        }
+
+
+        upgrade_main_savepoint($result, 2009082500);
+    }
+
     return $result;
 }
 
diff -urwN -X /home/jonathan/diff/exclude.txt mdl-cvshead/lib/grade/grade_object.php mdl20-mitms-integration/lib/grade/grade_object.php
--- mdl-cvshead/lib/grade/grade_object.php	2009-06-18 18:53:43.000000000 +1200
+++ mdl20-mitms-integration/lib/grade/grade_object.php	2009-08-25 16:20:28.000000000 +1200
@@ -23,12 +23,14 @@
 //                                                                       //
 ///////////////////////////////////////////////////////////////////////////
 
+require_once($CFG->libdir.'/data_object.php');
+
+
 /**
  * An abstract object that holds methods and attributes common to all grade_* objects defined here.
  * @abstract
  */
-abstract class grade_object {
-    public $table;
+abstract class grade_object extends data_object {
 
     /**
      * Array of required table fields, must start with 'id'.
@@ -37,19 +39,6 @@
     public $required_fields = array('id', 'timecreated', 'timemodified');
 
     /**
-     * Array of optional fields with default values - usually long text information that is not always needed.
-     * If you want to create an instance without optional fields use: new grade_object($only_required_fields, false);
-     * @var array $optional_fields
-     */
-    public $optional_fields = array();
-
-    /**
-     * The PK.
-     * @var int $id
-     */
-    public $id;
-
-    /**
      * The first time this grade_object was created.
      * @var int $timecreated
      */
@@ -62,133 +51,6 @@
     public $timemodified;
 
     /**
-     * Constructor. Optionally (and by default) attempts to fetch corresponding row from DB.
-     * @param array $params an array with required parameters for this grade object.
-     * @param boolean $fetch Whether to fetch corresponding row from DB or not,
-     *        optional fields might not be defined if false used
-     */
-    public function __construct($params=NULL, $fetch=true) {
-        if (!empty($params) and (is_array($params) or is_object($params))) {
-            if ($fetch) {
-                if ($data = $this->fetch($params)) {
-                    grade_object::set_properties($this, $data);
-                } else {
-                    grade_object::set_properties($this, $this->optional_fields);//apply defaults for optional fields
-                    grade_object::set_properties($this, $params);
-                }
-
-            } else {
-                grade_object::set_properties($this, $params);
-            }
-
-        } else {
-            grade_object::set_properties($this, $this->optional_fields);//apply defaults for optional fields
-        }
-    }
-
-    /**
-     * Makes sure all the optional fields are loaded.
-     * If id present (==instance exists in db) fetches data from db.
-     * Defaults are used for new instances.
-     */
-    public function load_optional_fields() {
-        global $DB;
-        foreach ($this->optional_fields as $field=>$default) {
-            if (array_key_exists($field, $this)) {
-                continue;
-            }
-            if (empty($this->id)) {
-                $this->$field = $default;
-            } else {
-                $this->$field = $DB->get_field($this->table, $field, array('id', $this->id));
-            }
-        }
-    }
-
-    /**
-     * Finds and returns a grade_object instance based on params.
-     * @static abstract
-     *
-     * @param array $params associative arrays varname=>value
-     * @return object grade_object instance or false if none found.
-     */
-    public static abstract function fetch($params);
-
-    /**
-     * Finds and returns all grade_object instances based on params.
-     * @static abstract
-     *
-     * @param array $params associative arrays varname=>value
-     * @return array array of grade_object insatnces or false if none found.
-     */
-    public static abstract function fetch_all($params);
-
-    /**
-     * Factory method - uses the parameters to retrieve matching instance from the DB.
-     * @static final protected
-     * @return mixed object instance or false if not found
-     */
-    protected static function fetch_helper($table, $classname, $params) {
-        if ($instances = grade_object::fetch_all_helper($table, $classname, $params)) {
-            if (count($instances) > 1) {
-                // we should not tolerate any errors here - problems might appear later
-                print_error('morethanonerecordinfetch','debug');
-            }
-            return reset($instances);
-        } else {
-            return false;
-        }
-    }
-
-    /**
-     * Factory method - uses the parameters to retrieve all matching instances from the DB.
-     * @static final protected
-     * @return mixed array of object instances or false if not found
-     */
-    public static function fetch_all_helper($table, $classname, $params) {
-        $instance = new $classname();
-
-        $classvars = (array)$instance;
-        $params    = (array)$params;
-
-        $wheresql = array();
-
-        foreach ($params as $var=>$value) {
-            if (!in_array($var, $instance->required_fields) and !array_key_exists($var, $instance->optional_fields)) {
-                continue;
-            }
-            if (is_null($value)) {
-                $wheresql[] = " $var IS NULL ";
-            } else {
-                $wheresql[] = " $var = ? ";
-                $params[] = $value;
-            }
-        }
-
-        if (empty($wheresql)) {
-            $wheresql = '';
-        } else {
-            $wheresql = implode("AND", $wheresql);
-        }
-
-        global $DB;
-        if ($datas = $DB->get_records_select($table, $wheresql, $params)) {
-            
-            $result = array();
-            foreach($datas as $data) {
-                $instance = new $classname();
-                grade_object::set_properties($instance, $data);
-                $result[$instance->id] = $instance;
-            }
-            return $result;
-
-        } else {
-            
-            return false;
-        }
-    }
-
-    /**
      * Updates this object in the Database, based on its object variables. ID must be set.
      * @param string $source from where was the object updated (mod/forum, manual, etc.)
      * @return boolean success
@@ -254,24 +116,6 @@
     }
 
     /**
-     * Returns object with fields and values that are defined in database
-     */
-    public function get_record_data() {
-        $data = new object();
-
-        foreach ($this as $var=>$value) {
-            if (in_array($var, $this->required_fields) or array_key_exists($var, $this->optional_fields)) {
-                if (is_object($value) or is_array($value)) {
-                    debugging("Incorrect property '$var' found when inserting grade object");
-                } else {
-                    $data->$var = $value;
-                }
-            }
-        }
-        return $data;
-    }
-
-    /**
      * Records this object in the Database, sets its id to the returned value, and returns that value.
      * If successful this function also fetches the new object data from database and stores it
      * in object properties.
@@ -308,51 +152,5 @@
         $this->notify_changed(false);
         return $this->id;
     }
-
-    /**
-     * Using this object's id field, fetches the matching record in the DB, and looks at
-     * each variable in turn. If the DB has different data, the db's data is used to update
-     * the object. This is different from the update() function, which acts on the DB record
-     * based on the object.
-     */
-    public function update_from_db() {
-        if (empty($this->id)) {
-            debugging("The object could not be used in its state to retrieve a matching record from the DB, because its id field is not set.");
-            return false;
-        }
-        global $DB;
-        if (!$params = $DB->get_record($this->table, array('id' => $this->id))) {
-            debugging("Object with this id:{$this->id} does not exist in table:{$this->table}, can not update from db!");
-            return false;
-        }
-
-        grade_object::set_properties($this, $params);
-
-        return true;
-    }
-
-    /**
-     * Given an associated array or object, cycles through each key/variable
-     * and assigns the value to the corresponding variable in this object.
-     * @static final
-     */
-    public static function set_properties(&$instance, $params) {
-        $params = (array) $params;
-        foreach ($params as $var => $value) {
-            if (in_array($var, $instance->required_fields) or array_key_exists($var, $instance->optional_fields)) {
-                $instance->$var = $value;
-            }
-        }
-    }
-
-    /**
-     * Called immediately after the object data has been inserted, updated, or 
-     * deleted in the database. Default does nothing, can be overridden to 
-     * hook in special behaviour.
-     *
-     * @param bool $deleted
-     */
-    function notify_changed($deleted) {
-    }
 }
 ?>
diff -urwN -X /home/jonathan/diff/exclude.txt mdl-cvshead/lib/simpletest/testcompletioncron.php mdl20-mitms-integration/lib/simpletest/testcompletioncron.php
--- mdl-cvshead/lib/simpletest/testcompletioncron.php	1970-01-01 12:00:00.000000000 +1200
+++ mdl20-mitms-integration/lib/simpletest/testcompletioncron.php	2009-08-25 16:20:28.000000000 +1200
@@ -0,0 +1,85 @@
+<?php  // $Id$
+
+///////////////////////////////////////////////////////////////////////////
+//                                                                       //
+// NOTICE OF COPYRIGHT                                                   //
+//                                                                       //
+// Moodle - Modular Object-Oriented Dynamic Learning Environment         //
+//          http://moodle.org                                            //
+//                                                                       //
+// Copyright (C) 1999 onwards Martin Dougiamas  http://dougiamas.com     //
+//                                                                       //
+// This program is free software; you can redistribute it and/or modify  //
+// it under the terms of the GNU General Public License as published by  //
+// the Free Software Foundation; either version 2 of the License, or     //
+// (at your option) any later version.                                   //
+//                                                                       //
+// This program is distributed in the hope that it will be useful,       //
+// but WITHOUT ANY WARRANTY; without even the implied warranty of        //
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         //
+// GNU General Public License for more details:                          //
+//                                                                       //
+//          http://www.gnu.org/copyleft/gpl.html                         //
+//                                                                       //
+///////////////////////////////////////////////////////////////////////////
+
+if (!defined('MOODLE_INTERNAL')) {
+    die('Direct access to this script is forbidden.');    ///  It must be included from a Moodle page
+}
+
+global $CFG;
+require_once($CFG->libdir.'/completion/cron.php');
+
+/**
+ * Unit tests for (some of) the course completion cron job
+ *
+ * @license http://www.gnu.org/copyleft/gpl.html GNU Public License
+ * @package formslib
+ */
+class completetion_cron_test extends UnitTestCase {
+    private $element;
+    public  static $includecoverage = array('lib/completion/cron.php');
+
+    function test_aggregation() {
+        // Test criteria aggregation
+
+        // Test COMPLETION_AGGREGATION_ANY
+        $status = null;
+        $method = COMPLETION_AGGREGATION_ANY;
+
+        completion_cron_aggregate($method, false, $status);
+        $this->assertEqual($status, false);
+
+        completion_cron_aggregate($method, false, $status);
+        $this->assertEqual($status, false);
+
+        completion_cron_aggregate($method, true, $status);
+        $this->assertEqual($status, true);
+
+        $status = null;
+
+        completion_cron_aggregate($method, true, $status);
+        $this->assertEqual($status, true);
+
+        completion_cron_aggregate($method, false, $status);
+        $this->assertEqual($status, true);
+
+        // Test COMPLETION_AGGREGATION_ALL
+        $status = null;
+        $method = COMPLETION_AGGREGATION_ALL;
+
+        completion_cron_aggregate($method, false, $status);
+        $this->assertEqual($status, false);
+
+        completion_cron_aggregate($method, true, $status);
+        $this->assertEqual($status, false);
+
+        $status = null;
+
+        completion_cron_aggregate($method, true, $status);
+        $this->assertEqual($status, true);
+
+        completion_cron_aggregate($method, false, $status);
+        $this->assertEqual($status, false);
+    }
+}
diff -urwN -X /home/jonathan/diff/exclude.txt mdl-cvshead/version.php mdl20-mitms-integration/version.php
--- mdl-cvshead/version.php	2009-08-25 15:24:09.000000000 +1200
+++ mdl20-mitms-integration/version.php	2009-08-25 16:20:56.000000000 +1200
@@ -6,7 +6,7 @@
 // This is compared against the values stored in the database to determine
 // whether upgrades should be performed (see lib/db/*.php)
 
-    $version = 2009080700;  // YYYYMMDD   = date of the last version bump
+    $version = 2009082500;  // YYYYMMDD   = date of the last version bump
                             //         XX = daily increments
 
     $release = '2.0 dev (Build: 20090825)';  // Human-friendly version name
